#ifndef __DB_TYPES_H__
#define __DB_TYPES_H__

#define VMTRUE		1
#define VMFALSE   	0

/*********/
/* WIN32 */
/*********/

#ifdef WIN32

#define NEED_INT_TYPES

typedef FILE VMFILE;
#define VM_fopen		fopen
#define VM_fclose		fclose
#define VM_fwrite		fwrite
#define VM_printf		printf
#define VM_vprintf		vprintf
#define VM_puts(s)		fputs(s, stdout)
#define VM_putchar		putchar
#define VM_flush		fflush(stdout)

#endif  // WIN32

/**********/
/* XGSPIC */
/**********/

#ifdef XGSPIC

#include <stdio.h>

#define NEED_INT_TYPES
#define NEED_CONSOLE_IO

#include "FSIO.h"
typedef FSFILE VMFILE;
#define VM_fopen		FSfopen
#define VM_fclose		FSfclose
#define VM_fwrite		FSfwrite

#endif  // XGSPIC

/**********/
/* XGSAVR */
/**********/

#ifdef XGSAVR

#include <stdint.h>

#define NEED_CONSOLE_IO

#endif  // XGSAVR

#ifdef NEED_INT_TYPES
typedef char int8_t;
typedef unsigned char uint8_t;
typedef short int16_t;
typedef unsigned short uint16_t;
#endif

#ifdef NEED_CONSOLE_IO
void VM_printf(char *fmt, ...);
void VM_vprintf(char *fmt, va_list ap);
void VM_puts(char *str);
void VM_putchar(int ch);
void VM_flush(void);
#endif

#endif
