/* db_types.h - type definitions for a simple virtual machine
 *
 * Copyright (c) 2009 by David Michael Betz.  All rights reserved.
 *
 */

#ifndef __DB_TYPES_H__
#define __DB_TYPES_H__

/**********/
/* Common */
/**********/

#define VMTRUE		1
#define VMFALSE   	0

/*********/
/* WIN32 */
/*********/

#ifdef WIN32

#include "../common/db_inttypes.h"

#include <stdio.h>
#include <string.h>

typedef FILE VMFILE;

#define CODE_BLOCK_SIZE     512
#define VMCODEBYTE(p)       *(uint8_t *)(p)

#endif  // WIN32

/**********/
/* XGSPIC */
/**********/

#ifdef XGSPIC

#include "../common/db_inttypes.h"

#include <stdio.h>
#include <string.h>

#include "FSIO.h"
typedef FSFILE VMFILE;

#define CODE_BLOCK_SIZE     1024
#define VMCODEBYTE(p)       *(uint8_t *)(p)

#endif  // XGSPIC

/**********/
/* XGSAVR */
/**********/

#ifdef XGSAVR

#include <stdint.h>
#include <string.h>
#include <avr/boot.h>
#include <avr/pgmspace.h>

typedef void VMFILE;

#define CODE_BLOCK_SIZE     256
#define VMCODEBYTE(p)	    pgm_read_byte(p)

#endif  // XGSAVR

#endif
