' 2010-11-24 initial version
con
  SXTVRENDEZVOUS = $8000 - 4
  SXKBRENDEZVOUS = SXTVRENDEZVOUS - 4
  SDSPIRENDEZVOUS = SXKBRENDEZVOUS - 3 * 4
  SXFS2RENDEZVOUS = SDSPIRENDEZVOUS - 4 * 4
  SXFSRENDEZVOUS = SXFS2RENDEZVOUS - 4 * 4
  METADATABUFFER = SXFSRENDEZVOUS - 512

  _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000
  _free     = ($8000 - METADATABUFFER) / 4

  tvPins    = 12                       ' TV I/O pins +0 to +2
  kbPins    = 26                       ' PS/2 I/O pins +0 and +1
  sdPinsCnt = 8  << 20                 ' SPI increment select counter
  sdPinsDO  = 9  << 0                  ' SPI MISO data from device
  sdPinsDI  = 10 << 5                  ' SPI MOSI data to device
  sdPinsClk = 11 << 10                 ' SPI clock
  sdPinsClr = 25 << 15                 ' SPI /clear select counter
  sdPinsSel = 5  << 25                 ' SD card select code
  sdPins    = sdPinsDO+sdPinsDI+sdPinsClk+sdPinsClr+sdPinsCnt+sdPinsSel

obj
  drv  : "isxfs"                       ' FAT File System Read/Write
  drvx : "sxfs"                        '  (starts up low level SPI)
  spi  : "isxspi"                      ' Driver for other SPI devices
  dsp  : "isxtv"                       ' Sphinx TV Text Driver
  dspx : "sxtv"
  kbd  : "isxkb"                       ' Sphinx Keyboard Driver
  kbdx : "sxkb"
  
var
  long fcb[4]
  long filestuff[drv#SIZEOFFILESTUFF/4]

pub main
  if dspx.start(tvPins,SXTVRENDEZVOUS) ' Start TV driver
     kbdx.start(kbPins)                ' Start keyboard
     drvx.start(sdPins)                ' Start SPI drivers
  dsp.str(string("Test Program",13))
  dsp.str(string("Flash: "))
  dsp.dec((spi.start * spi#secSize) >> 10)
  dsp.str(string("K free out of "))
  dsp.dec(spi.flashSize >> 20)
  dsp.str(string("MB",13))
  longfill(@fcb,-1,4)                  ' initialize FCB

  if drv.open(@filestuff,string("sphinx.bin"),"R")
    dsp.str(string("File not found",13))
  showSectors
  drv.close(@filestuff)
  dsp.str(string("Press any key to exit"))
  kbd.getkey                           ' wait for keypress
  dsp.out(13)
  reboot
  
pri showSectors | i, j, f0,f1,f2,f3    ' display sector headers
  repeat i from 0 to (spi.flashsize >> 12) - 1
    dsp.hex(i,3)
    dsp.out(" ")
    spi.readData(i<<12,@f0,16)         ' read sector header
    if f0.byte == $FF
      dsp.str(string(8,8,8,8))
    else
      repeat j from 0 to 7
        if f0.byte[j] <> $FF
          if f0.byte[j] < $20 or f0.byte[j] > $7E
            dsp.out("$")
            dsp.hex(f0.byte[j],2)
          else
            dsp.out(f0.byte[j])
      dsp.out(".")
      repeat j from 8 to 10
        if f0.byte[j] <> $FF
          if f0.byte[j] < $20 or f0.byte[j] > $7E
            dsp.out("$")
            dsp.hex(f0.byte[j],2)
          else
            dsp.out(f0.byte[j])
      dsp.out(" ")
      dsp.hex(f0.byte[11],2)
      dsp.out(" ")
      dsp.hex(f0.word[6],4)
      dsp.out(" ")
      dsp.hex(f0.word[7],4)
      dsp.out(13)

