''**************************
''*  Freeway for Propeller *
''*  Doug Dingus        .  *
''**************************

CON    'Driver constants

{ Hybrid Settings
_clkmode = xtal1 + pll16x
_xinfreq = 6_000_000
_stack = (100) >> 2   'accomodate display memory and stack
HYBRIDPINS=%011_0000
}

{ Proto/Demoboard Settings
_clkmode = xtal1 + pll16x
_xinfreq = 6_000_000
_stack = (100) >> 2   'accomodate display memory and stack
PROTOBOARDPINS=%001_0101
}

{ Hydra Settings
_clkmode = xtal1 + pll8x
_xinfreq = 10_300_000
_stack = (100) >> 2   'accomodate display memory and stack
HYBRIDPINS=%011_0000
}
  _clkmode = xtal1 + pll16x  '
  _xinfreq = 5_000_000 + 0_000 
  modepins=%001_0101

PAL=%0000
NTSC=%0001
INTERLACED=%0000

COGS = 2

x_tiles = 10 '*16=160
y_tiles = 12 '*16=192
mode = 0
'modepins = HYBRIDPINS
myhx = 17+(mode&1)*4

SPRX = 0
SPRY = 1
SPRP = 2
SPRC = 3

CON     'Constants required for game

OVER =       %0000_0000
INIT =       %0000_0001
ATTRACT =    %0000_0010
STOP =       %0000_0100
RUN =        %0000_1000



OBJ
  tv    : "JB_tv_030"
  rend  : "JB_drv_030"
  joystick : "gamepad_drv_001_hybrid.spin"

VAR     'Core working variables required for driver to operate
  long  frame                   'Frame counter
  long  nframe                  'Negative frame counter 
  long  rnd
  long  scrptr[2]               'screen buffer pointer
  byte  scrrendbuf[COGS*256]


    
PUB Main | i, c, temp, sptr

'-----------------------------------------------------------
'  Run Once Tasks Go Here
'-----------------------------------------------------------

      gstate := INIT                'Do nothing but draw background screen
      scanbufptr:=@scrrendbuf       'Point to screen data
      rend.start(COGS,@tvparams)    'launch render cogs
      tv.start(@tvparams)           'launch video cog
      joystick.start                'launch I/O cog
  
{

SPRITE NOTES

8x8 Sprites numbered from 0 - 255, indexed by SPRC

sptr allocation = one long per sprite

0-1   =   Chicken 0  SPRC 114, 116 ; SPRP 1
1-2   =   Chicken 1


Cars start at sprite 3 (sptr + 16) ; 64 Sprites Total Avaliable

Type 1 Small  =  2 Sprites, sptr + 8 ; SPRP 1 ; Start --> SPRC 96, 128  (8 cars total)

Type 2 Medium =  4 Sprites, sptr + 16 ; SPRP 1 ; Start --> SPRC 104, 105, 136, 137  (5 cars total)

Type 3 Large  =  8 Sprites, sptr + 32 ; SPRP 1 ; Start --> SPRC 160 - 163, 192 - 195 (3 cars total)


Upper Lanes Start Scan 24 ; 5 Lanes  Increasing

Lower Lanes Start Scan 104 ; 5 Lanes Increasing


TODO:  Random Car Field
          Direction, Type, Lane, Number Of
       Troubleshoot Palette Problem with Big Cars
       Pick way better colors :(
       Troubleshoot both chickens moving at once
       
Sample data renders at 2 cogs...

}




'------------------------------------------------------------
'  Run Game State Loop
'------------------------------------------------------------

  repeat                             'One loop per TV frame
    VSync                            'Lock Game logic to TV Frame

    if gstate == INIT
       game_time := 400   'SB 2:20 after testing
       frame:= 0
       nframe:= 0
       chick0y := 178
       chick1y := 178

       '[get set of cars ready to draw]

       
       gstate := ATTRACT



    if gstate == ATTRACT

       longmove(@sprites,@spritesbuf,sprite_count)         'Copy Sprite buffer to active sprite table
       sptr:=@spritesbuf                                   'Init Sprite buffer pointer

       joysticks := joystick.read

       Do_Chicken0(40, chick0y, sptr)     'sprites 0 & 1
       Do_Chicken1(112,chick1y, sptr+8)   'sprites 1 & 2

       sptr:=@spritesbuf + 16   'Start of dynamic sprites; depending on cars

  
       ' Small Sample Car           Upper Lane 2                                              
       byte[sptr][SPRX]:=nframe/2
       byte[sptr][SPRY]:=40
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=98
       sptr+=4
       byte[sptr][SPRX]:=nframe/2
       byte[sptr][SPRY]:=48
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=130
       sptr+=4

         'Small Sample Car                              Upper Lane 3
       byte[sptr][SPRX]:=nframe                         'Sprite screen position
       byte[sptr][SPRY]:=56                             'Sprite screen position
       byte[sptr][SPRP]:=1                              'Sprite palette from file, or...
       byte[sptr][SPRC]:=99                             'Sprite definition from file
       sptr+=4
       byte[sptr][SPRX]:=nframe
       byte[sptr][SPRY]:=56 + 8
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=131
       sptr+=4


       ' Medium Sample Car        Upper Lane 1
       byte[sptr][SPRX]:=frame/3
       byte[sptr][SPRY]:=24
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=104
       sptr+=4
       byte[sptr][SPRX]:=frame/3 + 8
       byte[sptr][SPRY]:=24
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=105
       sptr+=4
       byte[sptr][SPRX]:=frame/3                          'Sprite screen position
       byte[sptr][SPRY]:=32                                'Sprite screen position
       byte[sptr][SPRP]:=1                                 'Sprite palette from file, or...
       byte[sptr][SPRC]:=136                                'Sprite definition from file
       sptr+=4
       byte[sptr][SPRX]:=frame/3 + 8
       byte[sptr][SPRY]:=32
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=137
       sptr+=4
       

       ' Large Sample Car         Lower Lane 1   ***Palette Problem with this one  
       byte[sptr][SPRX]:=nframe
       byte[sptr][SPRY]:=104
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=160
       sptr+=4
       byte[sptr][SPRX]:=nframe + 8
       byte[sptr][SPRY]:=104
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=161
       sptr+=4
       byte[sptr][SPRX]:=nframe + 16                         'Sprite screen position
       byte[sptr][SPRY]:=104                                'Sprite screen position
       byte[sptr][SPRP]:=1                                 'Sprite palette from file, or...
       byte[sptr][SPRC]:=162                                'Sprite definition from file
       sptr+=4
       byte[sptr][SPRX]:=nframe + 24
       byte[sptr][SPRY]:=104
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=163
       sptr+=4


       byte[sptr][SPRX]:=nframe
       byte[sptr][SPRY]:=112
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=192
       sptr+=4
       byte[sptr][SPRX]:=nframe + 8
       byte[sptr][SPRY]:=112
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=193
       sptr+=4
       byte[sptr][SPRX]:=nframe + 16                          'Sprite screen position
       byte[sptr][SPRY]:=112                                'Sprite screen position
       byte[sptr][SPRP]:=1                                 'Sprite palette from file, or...
       byte[sptr][SPRC]:=194                               'Sprite definition from file
       sptr+=4
       byte[sptr][SPRX]:=nframe + 24
       byte[sptr][SPRY]:=112
       byte[sptr][SPRP]:=1
       byte[sptr][SPRC]:=195
       sptr+=4


    

    '--------------------------------------------------------
    '     Move Chickens
    '--------------------------------------------------------
    temp := joysticks & $0f     'Mask off the lower game pad state bits
   { 
    if joysticks == 2           'If down, add to chicken position
      chick0y := chick0y + 1
    if joysticks == 1           'If up, subtract
      chick0y := chick0y - 1
    }
    if joysticks & 4           'If down, add to chicken position
      chick0y := chick0y + 1
    if joysticks & 8           'If up, subtract
      chick0y := chick0y - 1
    
    temp := joysticks & $f0
    {
    if joysticks == 2           'If down, add to chicken position
      chick1y := chick1y + 1
    if joysticks == 1           'If up, subtract
      chick1y := chick1y - 1
  }
    if joysticks & $40           'If down, add to chicken position
      chick1y := chick1y + 1
    if joysticks & $80           'If up, subtract
      chick1y := chick1y - 1
      
    '---------------------------------------------------------
    '      Draw Chickens
    '---------------------------------------------------------


    '---------------------------------------------------------
    '      Check Chickens
    '---------------------------------------------------------
    Do_Collisions
    if chick0y == 10
      Update_Score0
      chick0y := 178
    if chick1y == 10
      Update_Score1
      chick1y := 178
    if chick0y == 179
      chick0y := 178
    if chick1y == 179
      chick1y := 178


    if gstate == RUN

       game_time --

      if game_time == 0
         gstate := STOP
      

    

  
   
   

  
    Do_Copyright_Anim  


PUB Do_Collisions
  'Maybe this has to happen during screen draw
  

      
PUB Do_Chicken0(X, Y, sptr) : anim

    anim := 0

    if (chick0y >> 2 & 1) == 1
      anim := 1

    byte[sptr][SPRX]:=X
    byte[sptr][SPRY]:=Y
    byte[sptr][SPRP]:=1
    byte[sptr][SPRC]:=114 + anim
    sptr+=4

    byte[sptr][SPRX]:=X
    byte[sptr][SPRY]:=Y+8
    byte[sptr][SPRP]:=1
    byte[sptr][SPRC]:=146 + anim
    sptr+=4



PUB Do_Chicken1(X, Y, sptr) : anim

    if (chick1y >> 2 & 1) == 1
      anim := 1

    byte[sptr][SPRX]:=X
    byte[sptr][SPRY]:=Y
    byte[sptr][SPRP]:=1
    byte[sptr][SPRC]:=114 + anim
    sptr+=4

    byte[sptr][SPRX]:=X
    byte[sptr][SPRY]:=Y+8
    byte[sptr][SPRP]:=1
    byte[sptr][SPRC]:=146 + anim
    sptr+=4

PUB Update_Score0 | i

    word[chrmap][5] := word[chrmap][5] + 1
    if (word[chrmap][5] == ("9" + 1))
      word[chrmap][5] := "0"
      word[chrmap][4] := "1"
    

PUB Update_Score1 | i
                         
    word[chrmap][14] := word[chrmap][14] + 1
    if (word[chrmap][14] == "9" + 1)
      word[chrmap][14] := "0"
      word[chrmap][13] := "1"
    
PUB Do_Copyright_Anim | i,s,d      
  repeat i from 0 to 7
    s:=@SpriteSet+get_copyright_scan((frame>>1),i)
    d:=@SpriteSet+($f0<<5)+i<<2
    long[d+$00]:=long[s+$00]
    long[d+$20]:=long[s+$20]
    long[d+$40]:=long[s+$40]
    long[d+$60]:=long[s+$60]
    long[d+$80]:=long[s+$80]
    long[d+$a0]:=long[s+$a0]
    
PUB get_copyright_scan(fr,of) | t
  fr&=255
  if(fr<128-8)
    t:=0
  elseif(fr<128)
    t:=fr-120
  elseif(fr<256-8)
    t:=8
  else
    t:=8+(fr-248)
  t:=(t+of)&15
  if(t<8)
    return ($0d<<5)+(t<<2)
  return ($12<<5)+(t<<2)
           
pub VSync
'  bordercolour:=$02
  repeat until VSyncVal<>2
  repeat until VSyncVal==2
'  bordercolour:=$2d
  if gstate <> STOP
    frame ++
    nframe --
              
DAT



' DO NOT ALTER ANYTHING FROM HERE ESPECIALLY LINE ORDER!
nextline      long      0                        
bordercolour  long      $02
tvparams      long      0               'status
              long      1               'enable
              long      modepins        'pins ' PROTO/DEMO BOARD = %001_0101 ' HYDRA = %011_0000
              long      mode            'mode
              long      10              'hc
              long      12              'vc
              long      myhx            'hx
              long      1               'vx
              long      0               'ho
              long      0               'vo
              long      50_000_000      '_xinfreq<<4  'broadcast
              long      0               'auralcog
scanbufptr    long      0
              long      @bordercolour+$10  'pointer to border colour
              long      @nextline+$10
              long      0
VSyncVal      long      0
dispptr       long      @displist+$10        
sprset        long      @SpriteSet+$10
chrmap        long      @scrmap+$10        
sprpal        long      @SpritePal+$10
cogcount      long      COGS
sprite_count  long      64
sprites       byte      0[64*4] 'this is the sprite list that gets draw
' DO NOT ALTER ANYTHING TO HERE ESPECIALLY LINE ORDER!

'Sprite list is 4 bytes per sprite, bytes are Xpos,Ypos,Palette,Charnum  Xpos 0 = showing at 0 onscreen, Ypos 0 = off top of screen, 8= showing at top line of display, that way when they are 0'd out, they're off screen :D Palette is colour index offset*16, 0=first 16 colours, 1=second 16 colours, Charnum=sprite character index
spritesbuf    byte      0[64*4] 'this is the sprite list buffer, so it can be updated without tears if drawing screen at the same time.

'Displist is made up of 192 * (8 bytes per scanline), each scanline is 5bytes ( 40 bits for each WIDE background pixel ), the next byte is background colour ( 0 in the 40bits ), the next byte is foreground colour ( 1 in the 40 bits ), the last byte is going to be border colour for that scanline.
'if background colour = 0 then it doesn't use the display list pixels, it uses scrmap as an 8x8 character map screen, 20x24 chars in total. each char is indexed from sprset's 16 colour characters
displist      byte      %00000000,%00000000,%00000000,%00000000,%00000000,$00,$cf,$02 '0
              byte      %00100000,%00000000,%00000000,%00000000,%00000110,$00,$ce,$02
              byte      %00110100,%00000000,%00000000,%00000000,%00101111,$00,$cd,$02
              byte      %00111100,%00000001,%10000000,%00000000,%00111111,$00,$cc,$02
              byte      %00111100,%00000001,%10000000,%00000000,%00111111,$00,$ca,$02 '4
              byte      %00111100,%00000001,%10000000,%00000000,%00111111,$00,$ca,$02
              byte      %00111100,%00000001,%10000000,%00000000,%00111111,$00,$ca,$02
              byte      %00111100,%00000001,%10000000,%00000000,%00111111,$00,$ca,$02                   'Score Text Lines
              
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$02,$ca,$02 '8
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$ca,$02 '12
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$02,$ca,$02 '16
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02 '20
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02 '24
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02 '28
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$06,$02 '32
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02 '36
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02 '40
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ca,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$03,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$03,$02 '44
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$06,$02 '48
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02 '52
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02 '56
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02 '60
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$06,$02 '64
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02 '68
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02 '72
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02 '76
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$06,$02 '80
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cb,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$03,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$03,$02 '84
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02 '88
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02 '92
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$7e,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02 '96       'Middle Of Screen
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$7e,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02 '100
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02 '104
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02 '108
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$06,$02 '112
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02 '116
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02 '120
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cc,$02 '124
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$cd,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$ce,$02
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$06,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '128
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '132
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '136
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '140
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$06,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '144
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '148
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '152
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '156
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$04,$06,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '160
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '164
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '168
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02 '172
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$04,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$02,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$00,$02 '176
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$00,$02 '180
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$05,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$02,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$00,$00,$02 '184
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$00,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$00,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$00,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$00,$00,$02 '188
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$00,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$00,$00,$02
              byte      %00000000,%00000000,%00000000,%00000000,%00000000,$00,$00,$02

'              byte      %10101010,%10101010,%10101010,%10101010,%10101010,$02,$2b,$02
'              byte      %01010101,%01010101,%01010101,%01010101,%01010101,$02,$2b,$02

scrmap        word      $20,$20,$20,$20,$20,"0",$20,$20,$20,$20,$20,$20,$20,$20,"0",$20,$20,$20,$20,$20 '  0
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 '  8
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 16
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 24
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 32
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 40
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 48
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 56
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 64
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 72
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 80
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 88
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ' 96
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 '104
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 '112
              word      $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 '120
              word      $00,$20,$20,$01,$02,$03,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$20,$20,$20,$20 '128
              word      $00,$20,$20,$20,$20,$20,$20,$20,$20,$20,$19,$19,$19,$20,$20,$20,$20,$20,$20,$20 '136
              word      $00,$20,$20,$20,$20,$20,$20,$20,$20,$20,$1a,$1a,$1a,$20,$20,$20,$20,$20,$20,$20 '144
              word      $00,$20,$20,$20,$20,$20,$20,$1b,$1b,$1b,$1b,$1b,$1b,$20,$20,$20,$20,$20,$20,$20 '152
              word      $00,$20,$20,$20,$20,$20,$20,$1c,$1c,$1c,$1c,$1c,$1c,$20,$20,$20,$20,$20,$20,$20 '160
              word      $00,$20,$20,$20,$20,$20,$20,"1","0","1","3","2","4",$20,$20,$20,$20,$20,$20,$20 '168
              word      $00,$00,$00,$00,$00,$00,$00,$f0,$f1,$f2,$f3,$f4,$f5,$00,$00,$00,$00,$00,$00,$00 '176
              word      $00,$00,$00,$00,$00,$00,$00,$f0,$f1,$f2,$f3,$f4,$f5,$00,$00,$00,$00,$00,$00,$00 '184

'SpriteSet and SpritePal are generated by the Bmp8ToLite.exe app and an 8bit bmp file called sprset.bmp, using
'Bmp8ToLite sprset -charmap16
'This generates two files, sprset.chr and sprset.pal
SpriteSet     file      "dd1-sprset.chr"
SpritePal     file      "dd1-sprset.pal"
              byte      $02, $03, $04, $05, $06, $07, $75, $86, $89, $38, $45, $02, $03, $04, $05, $06


DAT

game_time        long           0      'Atari 2:20 is the perfect game time.
joysticks        long           0
gstate           long           0      'Game State Flags
chick0y          long           0
chick1y          long           0
player0_score    long           0
player1_score    long           0