''************************************************
''*  TV Terminal              
''*  (C) 2005 Parallax, Inc.  
''
'' Modified History
'' 12/16/07
'' Andre' LaMothe
'' Added positional functions for version 011
''
'' setx(x) - set x cursor position
'' sety(y) - set y cursor position
'' getx    - retrieve x cursor position 
'' gety    - retrieve y cursor position
''
'' 7/10/10
'' Andre' LaMothe        
'' Tweaked to work with Prop C3 (pingrounp change etc. in tvparams)
'' version 012
''*************************************************

CON

  x_tiles = 16
  y_tiles = 13

  x_screen = x_tiles << 4
  y_screen = y_tiles << 4

  width = 0             '0 = minimum
  x_scale = 1           '1 = minimum
  y_scale = 1           '1 = minimum
  x_spacing = 6         '6 = normal
  y_spacing = 13        '13 = normal

  x_chr = x_scale * x_spacing
  y_chr = y_scale * y_spacing

  y_offset = y_spacing / 6 + y_chr - 1

  x_limit = x_screen / (x_scale * x_spacing)
  y_limit = y_screen / (y_scale * y_spacing)
  y_max = y_limit - 1

  y_screen_bytes = y_screen << 2
  y_scroll = y_chr << 2
  y_scroll_longs = y_chr * y_max
  y_clear = y_scroll_longs << 2
  y_clear_longs = y_screen - y_scroll_longs

  paramcount = 14       

VAR

OBJ


PUB start


PUB stop


PUB out(c)


' /////// ADDED FUNCTIONS /////////////////////////////////////////////////////

PUB setx(new_x)
' set x cursor position

PUB sety(new_y)
' set y cursor position

PUB getx
' retrieve x cursor position 
  return(0)

PUB gety
' retrieve y cursor position
  return(0) 


PUB erase
'' erases a character size block at the current cursor position, needed for editor implementation

' /////////////////////////////////////////////////////////////////////////////


PUB pstring(string_ptr)  | i

'' Print a zero-terminated string
PUB dec(value)  | i, z

'' Print a decimal number


PUB hex(value, digits)

'' Print a hexadecimal number

PUB bin(value, digits)

'' Print a binary number
PRI newline
                        