/* db_vmfcn.c - intrinsic functions
 *
 * Copyright (c) 2009 by David Michael Betz.  All rights reserved.
 *
 */

#include <stdlib.h>
#include "db_vm.h"

static void fcn_rnd(Interpreter *i);

void InitFcn(Interpreter *i)
{
	i->intrinsics[0] = fcn_rnd;
	i->intrinsics[1] = fcn_waitforvsync;
	i->intrinsics[2] = fcn_gamepad;
	i->intrinsics[3] = fcn_sound;
#ifdef BITMAP_GRAPHICS
	i->intrinsics[4] = fcn_plot;
	i->intrinsics[5] = fcn_line;
    i->intrinsics[6] = fcn_hline;
    i->intrinsics[7] = fcn_vline;
	i->intrinsics[8] = fcn_clear;
	i->intrinsics[9] = fcn_fillrect;
	i->intrinsics[10] = fcn_circle;
    i->intrinsics[11] = fcn_text;
#endif
#ifdef TILE_GRAPHICS
    i->intrinsics[4] = fcn_settilemap;
    i->intrinsics[5] = fcn_settiles;
    i->intrinsics[6] = fcn_setcolortable;
    i->intrinsics[7] = fcn_setsprite;
#endif
}

/* fcn_rnd - RND(n): return a random number between 0 and n-1 */
static void fcn_rnd(Interpreter *i)
{
    int n = i->sp[0];
    i->sp[-1] = rand() % n;
    Drop(i, 1);
}
