#include <stdio.h>
#include "propeller.h"

#ifdef BOARD_C3
#define LED_MASK    (1 << 15)
static void waitcnt(int cnt)
{
    while (--cnt >= 0)
        ;
}
static void blink(int repeat)
{
	DIRA |= LED_MASK;
    OUTA |= LED_MASK;
    while (--repeat >= 0) {
        OUTA ^= LED_MASK;
        waitcnt(10000);
    }
}
#endif

int main(void)
{
    int ch;
    
    // the traditional first test program
    iprintf("Hello, world!\n");
    
    // show propeller register access
    iprintf("CLKFREQ: %lu\n", CLKFREQ);
    iprintf("CNT %08x\n", CNT);
    iprintf("CNT %08x\n", CNT);
    iprintf("cogid() = %d\n", cogid());

    // blink the LED on the C3 a few times
#ifdef BOARD_C3
	blink(10);
#endif

    // echo characters using stdin and stdout
    while ((ch = getchar()) != -1)
        putchar(ch);

    return 0;
}
