/* db_chamvmavr.c - a simple virtual machine for the Chameleon AVR system
 *
 * Copyright (c) 2009 by David Michael Betz.  All rights reserved.
 *
 */

#include <stdio.h>
#include "../common/db_config.h"
#include "../runtime/db_vm.h"

/* code space in flash */
uint8_t __attribute__((section(".vmimage"))) vmimage[VMCODE_SIZE] = {
#include "ready.h"
};

/* data space in sram */
uint8_t vmdata[VMDATA_SIZE];

void VM_sysinit(int argc, char *argv[], const uint8_t **image, uint8_t **data, uint16_t *dataSize)
{
	VM_libinit(57600, VMCODEBASE(vmimage));
    *image = VMCODEADDR(vmimage);
    *data = vmdata;
    *dataSize = VMDATA_SIZE;
}

