/* db_config.h - target-specific configurations for a simple virtual machine
 *
 * Copyright (c) 2009-2010 by David Michael Betz.  All rights reserved.
 *
 */

#ifndef __DB_CONFIG_H__
#define __DB_CONFIG_H__

/**********/
/* XGSPIC */
/**********/

#ifdef XGSPIC

#define VMCODE_SIZE		        (16 * 1024)
#define VMDATA_SIZE    	        11600

#define XGS_COMMON
#define PIC_COMMON

#endif  // XGSPIC

/****************/
/* CHAMELEONPIC */
/****************/

#ifdef CHAMELEONPIC

#define VMCODE_SIZE		        (2 * 1024)
#define VMDATA_SIZE    	        1300

#define CHAMELEON_COMMON
#define PIC_COMMON

#endif  // CHAMELEONPIC

/**************/
/* PIC common */
/**************/

#ifdef PIC_COMMON

#include <stdio.h>
#include <string.h>
#include <libpic30.h>

#ifdef PIC24
#include <p24hxxxx.h>
#endif
#ifdef dsPIC33
#include <p33fxxxx.h>
#endif

#endif  // PIC_COMMON

/**********/
/* XGSAVR */
/**********/

#ifdef XGSAVR

#define VMCODE_SIZE		        (4 * 1024)
#define VMDATA_SIZE    	        2200

#define XGS_COMMON
#define AVR_COMMON

#endif  // XGSAVR

/****************/
/* CHAMELEONAVR */
/****************/

#ifdef CHAMELEONAVR

#define VMCODE_SIZE		        (2 * 1024)
#define VMDATA_SIZE    	        1300

#define CHAMELEON_COMMON
#define AVR_COMMON

#endif  // CHAMELEONAVR

/**************/
/* AVR common */
/**************/

#ifdef AVR_COMMON

#include <stdint.h>
#include <string.h>
#include <avr/boot.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>

#endif  // AVR_COMMON

/**************/
/* XGS common */
/**************/

#ifdef XGS_COMMON

#define RUNTIME_TARGET	TARGET_XGS

#endif  // XGS_COMMON

/********************/
/* CHAMELEON common */
/********************/

#ifdef CHAMELEON_COMMON

#define RUNTIME_TARGET	TARGET_CHAMELEON

#endif  // CHAMELEON_COMMON

#endif
