#include <stdio.h>
#include "vmlib.h"

void VM_printf(const char *fmt, ...)
{
    va_list ap;
    va_start(ap, fmt);
    VM_vprintf(fmt, ap);
    va_end(ap);
}

void VM_vprintf(const char *fmt, va_list ap)
{
    char buf[80], *p = buf;
    VMVSNPRINTF(buf, sizeof(buf), fmt, ap);
    while (*p != '\0')
        VM_putchar(*p++);
}

void VM_getline(char *buf, int size)
{
    int ch, max = size - 2, i = 0;

    for (;;) {
        switch (ch = VM_getchar()) {
        case '\r':
            VM_putchar('\r');
            VM_putchar('\n');
            buf[i++] = '\n';
            buf[i] = '\0';
            --size;
            return;
        case '\010':
        case '\177':
            if (i > 0) {
                VM_putchar('\010');
                VM_putchar(' ');
                VM_putchar('\010');
                --i;
            }
            break;
        default:
            if (i < max) {
                buf[i++] = ch;
                VM_putchar(ch);
            }
            break;
        }
    }
}

