/* vmlib.h - a virtual machine library
 *
 * Copyright (c) 2009-2010 by David Michael Betz.  All rights reserved.
 *
 */

#ifndef __VMLIB_H__
#define __VMLIB_H__

#include <stdarg.h>

#if defined(__PIC24HJ128GP502__)
#include "vmlibpic16.h"
#elif defined(__dsPIC33FJ128GP802__)
#include "vmlibpic16.h"
#elif defined(__PIC24HJ256GP206__)
#include "vmlibpic16.h"
#elif defined(AVR)
#include "vmlibavr.h"
#elif defined(WIN32)
#include "vmlibwin32.h"
#endif

void VM_libinit(unsigned long baudRate, VMCODEBASE_t imageBase);
void VM_printf(const char *fmt, ...);
void VM_vprintf(const char *fmt, va_list ap);
void VM_getline(char *buf, int size);
int VM_getchar(void);
void VM_putchar(int ch);
void vmcodecopy(uint8_t *dst, const uint8_t *src, int cnt);
int vmstrlen(const uint8_t *str);

#endif
