#ifndef __VMLIBAVR_H__
#define __VMLIBAVR_H__

#include <stdint.h>
#include <string.h>
#include <avr/pgmspace.h>

typedef unsigned int VMCODEBASE_t;

#define VMCODEBASE(p)			0
#define VMCODEADDR(p)			(p)

#define FLASH_SPACE             PROGMEM

#define VMCODEBYTE(p)	        pgm_read_byte(p)
#define VMCODECOPY(d, s, c)     memcpy_P(d, s, c)
#define VMINTRINSIC(i)          ((IntrinsicFcn *)pgm_read_word(&Intrinsics[i]))
#define VMCOPY(d, s, c, h)      do {                        \
                                    if (h)                  \
                                        memcpy(d, s, c);    \
                                    else                    \
                                        memcpy_P(d, s, c);  \
                                } while (0)
#define VMGETBYTE(p, h)         ((h) ? *(uint8_t *)(p) : VMCODEBYTE(p))
#define VMSTRLEN(p)             strlen_P((char *)p)
#define VMSTRNCMP(a, b, n)      strncmp_P((char *)a, (char *)b, n)
#define VMVSNPRINTF             vsnprintf_P

#endif
