/* vmlibpic16.h - a virtual machine library definitions for the pic24 and dspic33
 *
 * Copyright (c) 2009-2010 by David Michael Betz.  All rights reserved.
 *
 */

#ifndef __VMLIB_PIC16__
#define __VMLIB_PIC16__

#include <string.h>

typedef short int16_t;
typedef unsigned short uint16_t;
typedef char int8_t;
typedef unsigned char uint8_t;

typedef unsigned int VMCODEBASE_t;

#define VMCODEBASE(p)			__builtin_tblpage(p)
#define VMCODEADDR(p)			__builtin_tbloffset(p)

#define FLASH_SPACE				const

#define VMCODEBYTE(p)           ({                              \
                                    register int v;             \
                                    asm("tblrdl.b [%1], %0\n\t" \
                                        "ze %0, %0"             \
                                        : "=r"(v) : "r"(p));    \
                                    v;                          \
                                })                                
#define VMCODECOPY(d, s, c)     vmcodecopy(d, s, c)
#define VMSTRLEN(p)             vmstrlen(p)
#define VMINTRINSIC(i)          Intrinsics[i]
#define VMCOPY(d, s, c, h)      do {                            \
                                    if (h)                      \
                                        memcpy(d, s, c);        \
                                    else                        \
                                        VMCODECOPY(d, s, c);    \
                                } while (0)
#define VMGETBYTE(p, h)         ((h) ? *(uint8_t *)(p) : VMCODEBYTE(p))
#define VMSTRNCMP(a, b, n)      strncmp(a, b, n)
#define VMVSNPRINTF             vsnprintf

// not defined but actually located in the gcc library!
int vsnprintf(char *, size_t, const char *, va_list);

char *itoa(int value, char *string, int radix);

#endif
