/* db_xgsvmavr.c - a simple virtual machine for the XGS AVR system
 *
 * Copyright (c) 2009 by David Michael Betz.  All rights reserved.
 *
 */

#include "XGS_AVR_GAMEPAD_DRV_V010.h"
#include "XGS_AVR_SOUND_DRV_V010.h"

#include <stdio.h>
#include "../common/db_config.h"
#include "../runtime/db_vm.h"

/* code space in flash */
uint8_t __attribute__((section(".vmimage"))) vmimage[VMCODE_SIZE] = {
#include "ready.h"
};

/* data space in sram */
uint8_t vmdata[VMDATA_SIZE];

void VM_sysinit(int argc, char *argv[], const uint8_t **image, uint8_t **data, uint16_t *dataSize)
{
    VM_libinit(19200, VMCODEBASE(vmimage));
    Gamepad_Init();
    Sound_Init();
    *image = VMCODEADDR(vmimage);
    *data = vmdata;
    *dataSize = VMDATA_SIZE;
}
