/* db_xgsvmpic.c - a simple virtual machine for the XGS PIC system
 *
 * Copyright (c) 2009-2010 by David Michael Betz.  All rights reserved.
 *
 */

#include <stdio.h>
#include "../common/db_config.h"
#include "../runtime/db_vm.h"

/* code space in flash */
const uint8_t __attribute__((address(0x8000), space(prog))) vmimage[VMCODE_SIZE] = {
#include "ready.h"
};

/* data space in sram */
uint8_t vmdata[VMDATA_SIZE] __attribute__((far));

void VM_sysinit(int argc, char *argv[], const uint8_t **image, uint8_t **data, uint16_t *dataSize)
{
    VM_libinit(115200, VMCODEBASE(vmimage));
    *image = (const uint8_t *)VMCODEADDR(vmimage);
    *data = vmdata;
    *dataSize = VMDATA_SIZE;
}
