#ifndef __BOARD_DRACBLADE_H__
#define __BOARD_DRACBLADE_H__

/*
Pins 0-11 = ram access and external latches etc
Pin 12-15 = SD card (12=DO, 13=CLK, 14=DI, 15=CS)
Pin 16-23 = VGA as per the demo board.
Pin 16-18 = TV 
Pin 24,25 = second serial port (24=data out)
Pin 24,25 = mouse (shared with second serial port, use a jumper to select)
Pin 26,27 = keyboard
Pin 28,29 = eeprom
Pin 30,31 = programming serial port
*/

#define conRxPin    31        // the RX pin to use for UART console
#define conTxPin    30        // the TX pin to use for UART console
#define conMode     0         // the mode to use for FullDuplex UART console
#define conBaud     115200    // the baud rate to use for UART console

#define spiDO       12
#define spiClk      13
#define spiDI       14
#define spiCS       15

#define tvPin       16        // the TV DAC start pin to use for TV out

#define keybdPinC   26        // keyboard clock pin SCL
#define keybdPinD   27        // keyboard data pin SDA

#endif
